#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <windows.h>
#include <time.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <fftw3.h>
#include "bmp_loader.h"


#define FFTW_PLAN fftw_plan
#define FFTW_COMPLEX fftw_complex
#define FFTW_EXCUTE fftw_execute
#define FFTW_DFT  fftw_plan_dft_2d
#define FFTW_MALLOC fftw_malloc


// ͉摜FFT
FFTW_COMPLEX *fftw_f;
FFTW_COMPLEX *fftw_F;
FFTW_PLAN fftwfPlanF;
// KEXtB^̌
FFTW_COMPLEX *fftw_i;
FFTW_COMPLEX *fftw_I;
FFTW_PLAN fftwfPlani;



// ӂ2DKEVAtB^@x
void gauss2D(unsigned char *in, double *out, int w, int h, double sigma){

	int size = floor(6.0 * sigma) + 1;
	double mask[4096];
	double sigma2 = sigma * sigma;
	int ptr = 0;
	for(int sy = -size;sy <= size;sy++){
		for(int sx = -size;sx <= size;sx++, ptr++){

			float p = exp( -(sx*sx+sy*sy)/(2.0 * sigma2)) / (2.0 * sigma2 * M_PI);
			mask[ptr] = p;
		}
	}

	for(int y = size;y < h - size;y++){
		for(int x = size;x < w - size;x++){

			ptr = 0;
			float sum = 0;
			for(int sy = -size;sy <= size;sy++){
				for(int sx = -size;sx <= size;sx++, ptr++){
					sum += (mask[ptr] * in[x + sx + (y + sy) * w]);
				}
			}
			out[x + y * w] = sum;			
		}
	}
}

//**************************************************
// KEXtB^{tees
//  KEXtB^͓IɃt[Gϊl
//  gԂŏݍŃKEXtB^
void convolv_gauss(int i, int w, int h, double sigma)
{
	int x, y, ptr, wh;
	double rx, ry, gr, gi;
	int hw, hh;
	wh = w * h;

	hw = w * 0.5;
	hh = h * 0.5;
	for(ptr = y = 0;y < h;y++){
		ry = y;
		// ܂Ԃ
		if(ry >= hh)ry = ry - h;
		// [-, +]͈̔͂ɂ
		ry = M_PI * ry / (double)(hh);
		for(x = 0;x < w;x++, ptr++){
			rx = x;
			// ܂Ԃ
			if(rx >= hw)rx = rx - w;
			// [-, +]͈̔͂ɂ
			rx = M_PI * rx / (double)(hw);

			// KEX֐̃t[Gϊ̓KEX֐
			gr = exp(-0.5*(rx*rx+ry*ry)*(sigma*sigma));
			// ݍ
			fftw_I[ptr][0] =  fftw_F[ptr][0] * gr;
			fftw_I[ptr][1] =  fftw_F[ptr][1] * gr;
		}
	}
	// IFFT
	FFTW_EXCUTE(fftwfPlani);
};



// C
int main(int argc, char *argv[])
{

	char filename[256] = "./lenna.bmp";
	unsigned char *in;
	int i,  w, h, wh;
	double scale;
	int x, y, ptr;
	
	// ͉摜ǂݍ
	load_bmp_gray(filename, &in, &w, &h);
	wh = w * h;
	scale = 1.0 / wh;
	// zm
	fftw_f = (FFTW_COMPLEX *)FFTW_MALLOC(sizeof(FFTW_COMPLEX)*w*h);
	fftw_F = (FFTW_COMPLEX *)FFTW_MALLOC(sizeof(FFTW_COMPLEX)*w*h);
	// plan ̍쐬
	fftwfPlanF = FFTW_DFT(h, w, fftw_f, fftw_F, FFTW_FORWARD, FFTW_MEASURE);		
	// f[^Rs[
	for(ptr = 0; ptr < wh; ptr++){
		fftw_f[ptr][0] = in[ptr]* scale;
		fftw_f[ptr][1] = 0.0;
	};

	// ͉摜FFT
	FFTW_EXCUTE(fftwfPlanF);

	double *ref  = new double[w * h];
	unsigned char *tmp = new unsigned char[w * h];

	double sigma;

	// tB^[eesʂRs[
	fftw_I = (FFTW_COMPLEX *)FFTW_MALLOC(sizeof(FFTW_COMPLEX)*w*h);
	fftw_i = (FFTW_COMPLEX *)FFTW_MALLOC(sizeof(FFTW_COMPLEX)*w*h);
	fftwfPlani = FFTW_DFT(h, w, fftw_I, fftw_i, FFTW_BACKWARD, FFTW_MEASURE);	

	// sigma낢ςďo
	int n;
	double ave_RMSE = 0.0;
	double ave_n    = 0.0;
	for(n = 0;n < 40;n++){
		sigma = 1.0 + n * 0.1;

		double err = 0.0;
		gauss2D(in, ref, w, h, sigma);
		int B = floor(6*sigma) + 1;
		memset(tmp ,0, w * h);
		convolv_gauss(0, w, h, sigma);
		for(y = B;y < h - B;y++){
			for(x = B;x < w - B;x++)
			{
				ptr = x + y * w;
				double p = ref[ptr];
				err += (p - fftw_i[ptr][0]) * (p - fftw_i[ptr][0]);
				tmp[ptr] = min(max(p, 0), 255); 
			};
		}
		// t@XƂ̍o
		double RMSE = sqrt(err / (double)(wh));
		printf("%2d:sigma=%.1f, RMS error=%.4f\n", n, sigma, RMSE);
		ave_RMSE += RMSE;
		ave_n++;
	}
	ave_RMSE /= ave_n;
	printf("average RMSE=%.4f\n", ave_RMSE);

	// [N
	delete in;
	fftw_free(fftw_i);
	fftw_free(fftw_I);
	fftw_free(fftw_f);
	fftw_free(fftw_F);
	
	return 0;
};
